#include <stdio.h>

int heure, minute, seconde; // variables globales
    /* Affichage */
void printTime() {
    if ((heure == 0) && (minute == 0) && (seconde == 0)) {
        printf("*** BOUM!!! ***\n");
        return;  // permet de sortir de la fonction ici
    }
    printf("%d heure%s ",   heure,   (heure > 1)  ? "s" : "");
    printf("%d minute%s ",  minute,  (minute > 1) ? "s" : "");
    printf("%d seconde%s ", seconde, (seconde > 1)? "s" : "");
    printf("avant explosion!\n");
}
    /* Affectation des variables globales heure, minute et seconde */
int setTime(int h, int m, int s) {
    if ((h >= 0) && (h <= 24) && (m >= 0) && (m <= 60) && (s >= 0) && (s <= 60)) {
        heure   = h;
        minute  = m;
        seconde = s;
        return 0;
    }
    printf("Erreur de format dans l'heure (h=%d, m=%d, s=%d)!\n",h,m,s);
    return 1;
}
    /* dcrmente l'heure de 1 seconde */
void tick() {
    seconde--; 
    if (seconde < 0) {
        seconde = 59;
        minute--;
        if (minute < 0) {
            minute = 59;
            heure--;
        }
    }
}
    /* Une procdure pour faciliter les tests */
void test(int h,int m, int s) {
    setTime(h,m,s);
    printf("Dbut : "); printTime();
    tick();
    printf("Fin   : "); printTime();
    printf("\n");
}

int main()
{
    test(0,0,1);
    test(0,0,2);
    test(0,1,0);
    test(1,0,0);
    test(25,0,75);
    return 0;
}

