#include <stdio.h>
#include <math.h>

void solve_eqn_1er_deg(float a, float b);// voir exercice/*@\ref{chap:syntaxe}.\ref{syntaxe:eqn_1er_deg}@*/
    /* rsout l'quation du premier degr ax^2 + bx+c = 0 */
void solve_eqn_2eme_deg(float a, float b, float c) {
    if (a == 0) solve_eqn_1er_deg(b,c);
    else {
        float delta = b*b - 4*a*c;
        if      (delta < 0)  printf("S = ensemble vide (aucune solution)\n");
        else if (delta == 0) printf("S = {%f} (une solution souble)\n",-b/(2*a));
             else // ici, delta > 0
		 printf("S = {%f, %f} (deux solutions)\n", 
			(-b - sqrt(delta))/(2*a), (-b + sqrt(delta))/(2*a));        
    }
}
int main() 
{
    float a, b, c;
    printf("*** Rsolution automatique de l'quation (en x) a.x^2+b.x+c = 0 ***\n");
    printf("a = ");  scanf("%f", &a);
    printf("b = ");  scanf("%f", &b);
    printf("c = ");  scanf("%f", &c);
    printf("-> rsolution de %fx^2 + %f.x + %f = 0\n",a,b,c);
    solve_eqn_2eme_deg(a,b,c);
    return 0;
}

    /* rsoud l'equation du premier degr ax + b = 0 */
void solve_eqn_1er_deg(float a, float b) {
    if (a == 0) {
        if (b == 0) printf("S = R (tout rel x est solution)\n");
        else        printf("S = ensemble vide (aucune solution relle)\n");
    } else { // ici, a != 0 et on peut donc diviser par a!
        printf("S = {%f} (une unique solution)\n",-b/a);
    }
}
