#include <sys/types.h>
#include <assert.h>
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

void affichefichier(int descr) {
	char c;
	while(read(descr, &c, 1) == 1) {
                if (write(STDOUT_FILENO, &c, 1) == -1) {
			perror("write a renvoy: ");
			return; /* on ne peut pas y faire grand chose... */
		}
        }
}

int main(int argc, char *argv[])
{
	if (argc < 2) {
	    fprintf(stderr, "Usage: %s fichier1 [fichier2 [...]]\n", argv[0]);
		return 1;
	}
	int i;
	for (i = 1; i < argc; i++) {
		assert(argv[i] != NULL);
		int fd = open(argv[i], O_RDONLY, 0);
		if (fd < 0) {
			fprintf(stderr, "Erreur d'ouverture du fichier %s: %s\n",
				argv[i], strerror(errno));
			continue;
		}
		affichefichier(fd);
		close(fd);
	}
	return 0;
}
