#include <sys/types.h>
#include <errno.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

int main()
{
	int fpid = fork();

	switch(fpid) {
	case -1:
		fprintf(stderr, "fork a chou: %s\n", strerror(errno));
		return 1;
	case 0:
		fprintf(stderr, "Je suis le fils: mon pid est %d,"
			" celui de mon pre est %d\n", getpid(), getppid());
		sleep(2);
		return 0;
	default:
		fprintf(stderr, "Je suis le pre: mon pid est %d,"
			" celui de mon fils est %d\n", getpid(), fpid);
		sleep(2);
		return 0;
	}
}
