#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

int main()
{
	char c;
	int descfich[2];
	if (pipe(descfich))   return EXIT_FAILURE;

	switch (fork()) {
	case -1:
		return EXIT_FAILURE;
	case 0: /* fils */
		close(descfich[1]);
		while(read(descfich[0], &c, 1) == 1) {
			putchar(c);
		}
		return 0;
	default: /* pre */
		close(descfich[0]);
		while (read(STDIN_FILENO, &c, 1) == 1) {
			write(descfich[1], &c, 1);
		}
		return 0;
	}
}
