#include <stdio.h>
#include <stdarg.h>

int min(int first, ...) {
	va_list ap;          // La liste des arguments.
	va_start(ap, first); // Initialisation de la structure ap.
	int res = first, next = first;
	while (next >= 0) {
		if (next < res) res = next;
		next = va_arg(ap, int); // On rcupre le prochain argument.
	}
	va_end(ap); // Fin d'utilisation de ap.
	return res;
}

int main()
{
	int m1 = min(14,5,17,2,11,-1); // -1 indique la fin de la liste d'arguments.
	int m2 = min(27,11,79,-1);
	printf("m1 = %d \t m2 = %d\n",m1,m2);
	return 0;
}
